(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('lodash'), require('@angular/core'), require('@angular/common'), require('@farris/ui-datagrid'), require('@farris/ui-datagrid-editors'), require('@farris/ui-list-nav'), require('@farris/ui-list-view'), require('@farris/ui-combo-list'), require('@farris/ui-section'), require('@ecp-caf/caf-common'), require('@farris/ui-sidebar'), require('@farris/ui-forms'), require('@farris/ui-modal'), require('@angular/forms'), require('@farris/ui-messager'), require('@farris/ui-notify'), require('@farris/ui-view-change'), require('@farris/ui-datepicker'), require('@farris/ui-input-group'), require('@farris/ui-tabs'), require('@farris/ui-treetable')) :
    typeof define === 'function' && define.amd ? define('@gsp-svc/message-user-selector', ['exports', 'lodash', '@angular/core', '@angular/common', '@farris/ui-datagrid', '@farris/ui-datagrid-editors', '@farris/ui-list-nav', '@farris/ui-list-view', '@farris/ui-combo-list', '@farris/ui-section', '@ecp-caf/caf-common', '@farris/ui-sidebar', '@farris/ui-forms', '@farris/ui-modal', '@angular/forms', '@farris/ui-messager', '@farris/ui-notify', '@farris/ui-view-change', '@farris/ui-datepicker', '@farris/ui-input-group', '@farris/ui-tabs', '@farris/ui-treetable'], factory) :
    (factory((global['gsp-svc'] = global['gsp-svc'] || {}, global['gsp-svc']['message-user-selector'] = {}),global._,global.ng.core,global.ng.common,global.uiDatagrid,global.uiDatagridEditors,global.uiListNav,global.uiListView,global.uiComboList,global.uiSection,global.cafCommon,global.uiSidebar,global.uiForms,global.uiModal,global.ng.forms,global.uiMessager,global.uiNotify,global.uiViewChange,global.uiDatepicker,global.uiInputGroup,global.uiTabs,global.uiTreetable));
}(this, (function (exports,_,core,common,uiDatagrid,uiDatagridEditors,uiListNav,uiListView,uiComboList,uiSection,cafCommon,uiSidebar,uiForms,uiModal,forms,uiMessager,uiNotify,uiViewChange,uiDatepicker,uiInputGroup,uiTabs,uiTreetable) { 'use strict';

    _ = _ && _.hasOwnProperty('default') ? _['default'] : _;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var RecipientType = {
        Organize: 0,
        Position: 1,
        User: 2,
    };
    RecipientType[RecipientType.Organize] = 'Organize';
    RecipientType[RecipientType.Position] = 'Position';
    RecipientType[RecipientType.User] = 'User';
    var Result = /** @class */ (function () {
        function Result() {
        }
        return Result;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MessageUserSelectorComponent = /** @class */ (function () {
        function MessageUserSelectorComponent(http) {
            this.http = http;
            this.columns = [];
            this.treedata = []; //当前所有组织信息
            //当前所有组织信息
            this.groupIcon = '<span class="f-icon f-icon-search"></span>';
            this.searchText = "";
            this.orgList = [];
            this.posList = [];
            //orgInfos=[];
            this.userInfos = []; //当前所有用户信息
            //当前所有用户信息
            this.recipientInfos = []; //已选用户信息
            //已选用户信息
            this.orgItems = []; //数据绑定数据
            //数据绑定数据
            this.posItems = []; //组织绑定数据
            //全选标识
            this.orgUserCount = 0;
            this.posuserCount = 0;
            this.isChildren = false; //组织根据是否进到子级分别显示
            //组织根据是否进到子级分别显示
            this.tabsLebel = "Organize"; //tab选择标识
            //tab选择标识
            this.selectedData = []; //右侧选择数据集
            //右侧选择数据集
            this.selectedAllCount = 0; //已选择总项
            //已选择总项
            this.selectedUserCount = 0; //已选择人数
            //已选择人数
            this.selectedOrgCount = 0; //已选择组织数
            //已选择组织数
            this.selectedPosCount = 0; //已选择岗位数
            //外部注入数据
            this.hasExpandOrg = [];
            this.imgSrc = '/platform/runtime/msg/web/message-center/assets/message-center-icon/default-user.svg';
            //用户字段格式
            this.UserFieldFormatter = ( /**
             * @param {?} val
             * @param {?} data
             * @return {?}
             */function (val, data) {
                if (data.recipientType == 2) {
                    return '<div class="align-items-center d-flex"><img class="ap-img" height="25" width="25" src="/platform/runtime/msg/web/message-center/assets/message-center-icon/default-user.svg">&nbsp;' + data.name + '</div>';
                }
                else
                    return data.name;
            });
        }
        /**
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.hasExpandOrg = [];
                this.columns = [
                    { field: 'name', title: "名称", width: 80, formatter: this.UserFieldFormatter },
                ];
                /** @type {?} */
                var landUser = (( /** @type {?} */(top.window))).gspframeworkService.common.userInfos.get();
                this.sysOrgRoot = {
                    data: {
                        "id": landUser.tenantId,
                        "code": landUser.tenantId,
                        "name": landUser.tenantName,
                        "parentId": "",
                        "parentName": "",
                        "isDetail": false,
                        "recipientType": RecipientType.Organize,
                        "userNumber": 0,
                    },
                    parent: null,
                    children: [],
                    expanded: true
                };
                this.treedata.push(this.sysOrgRoot);
                this.orgList.push(this.sysOrgRoot);
                this.convertOrgTree();
                this.convertPosTree();
                this.selectedData = [];
            };
        //核心数据转化
        //核心数据转化
        /**
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.convertOrgTree =
            //核心数据转化
            /**
             * @return {?}
             */
            function () {
                var _this = this;
                this.getOrgsByLayer(1).subscribe(( /**
                 * @param {?} orgs
                 * @return {?}
                 */function (orgs) {
                    if (orgs) {
                        orgs.forEach(( /**
                         * @param {?} item
                         * @return {?}
                         */function (item) {
                            if (item.code !== "25") {
                                /** @type {?} */
                                var org = {
                                    data: {
                                        "id": item.id,
                                        "code": item.code,
                                        "name": item.name,
                                        "parentId": item.parentId,
                                        "isDetail": item.isDetail,
                                        "recipientType": RecipientType.Organize,
                                        "userNumber": 0,
                                        "parentName": ""
                                    },
                                    parent: null,
                                    children: [],
                                    expanded: false
                                };
                                /** @type {?} */
                                var orgChild = {
                                    data: {
                                        "id": _this.newGuid(),
                                        "code": "",
                                        "name": "",
                                        "parentId": "",
                                        "isDetail": true,
                                        "recipientType": RecipientType.User,
                                        "userNumber": 0,
                                        "parentName": "",
                                        "children": [],
                                    },
                                    parent: org,
                                    children: [],
                                    expanded: false
                                };
                                org.children.push(orgChild);
                                org.data.parentName = _this.sysOrgRoot.name;
                                _this.sysOrgRoot.children.push(org);
                                _this.orgItems.push(org);
                            }
                        }));
                        _this.treedata = __spread(_this.treedata);
                        _this.orgList;
                        //注入数据显示
                        if (_this.injectorData && _this.injectorData != "") {
                            /** @type {?} */
                            var showDatas = JSON.parse(_this.injectorData);
                            showDatas.forEach(( /**
                             * @param {?} item
                             * @return {?}
                             */function (item) {
                                if (item.recipientType == 0) {
                                    _this.getUsersByOrgId(item.id).subscribe(( /**
                                     * @param {?} users
                                     * @return {?}
                                     */function (users) {
                                        /** @type {?} */
                                        var orgUserItem = _this.orgItems.find(( /**
                                         * @param {?} data
                                         * @return {?}
                                         */function (data) { return data.data.id === item.id && data.data.recipientType == 0; }));
                                        if (orgUserItem) {
                                            orgUserItem.data.userNumber = users.totalCount;
                                            _this.selectedData.push(orgUserItem.data);
                                        }
                                        else {
                                            _this.selectedData.push({
                                                "id": item.id,
                                                "name": item.name,
                                                "recipientType": item.recipientType,
                                                "userNumber": users.totalCount
                                            });
                                        }
                                        _this.selectedOrgCount++;
                                        _this.selectedAllCount++;
                                    }));
                                }
                                if (item.recipientType == 1) {
                                    _this.getPosByPosId(item.id).subscribe(( /**
                                     * @param {?} poss
                                     * @return {?}
                                     */function (poss) {
                                        /** @type {?} */
                                        var pos = poss[0];
                                        /** @type {?} */
                                        var posItem = {
                                            "id": pos.id,
                                            "code": pos.code,
                                            "name": pos.name,
                                            "parentId": "",
                                            "isDetail": true,
                                            "recipientType": RecipientType.Position,
                                            "userNumber": 0,
                                            "parentName": "",
                                            "children": [],
                                        };
                                        _this.selectedData.push(posItem);
                                        _this.selectedPosCount++;
                                        _this.selectedAllCount++;
                                    }));
                                }
                                if (item.recipientType == 2) {
                                    _this.getUserById(item.id).subscribe(( /**
                                     * @param {?} users
                                     * @return {?}
                                     */function (users) {
                                        /** @type {?} */
                                        var user = users[0];
                                        /** @type {?} */
                                        var orgUserItem = {
                                            "id": user.id,
                                            "code": user.code,
                                            "name": user.name,
                                            "parentId": "",
                                            "isDetail": true,
                                            "recipientType": RecipientType.User,
                                            "userNumber": 0,
                                            "parentName": user.sysOrgName,
                                            "children": [],
                                        };
                                        _this.selectedData.push(orgUserItem);
                                        _this.selectedUserCount++;
                                        _this.selectedAllCount++;
                                    }));
                                }
                            }));
                            _this.selectedData = __spread(_this.selectedData);
                        }
                    }
                }));
            };
        /**
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.convertPosTree = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.getAllPoss().subscribe(( /**
                 * @param {?} poss
                 * @return {?}
                 */function (poss) {
                    poss.forEach(( /**
                     * @param {?} element
                     * @return {?}
                     */function (element) {
                        /** @type {?} */
                        var showDatas;
                        /** @type {?} */
                        var posInfo = {
                            data: {
                                "id": element.id,
                                "code": element.code,
                                "name": element.name,
                                "parentId": "",
                                "parentName": "",
                                "isDetail": false,
                                "recipientType": RecipientType.Position,
                                "userNumber": 0,
                                "children": [],
                            },
                            parent: null,
                            children: [],
                            expanded: false
                        };
                        /** @type {?} */
                        var posChild = {
                            data: {
                                "id": _this.newGuid(),
                                "code": "",
                                "name": "",
                                "parentId": "",
                                "isDetail": true,
                                "recipientType": RecipientType.User,
                                "userNumber": 0,
                                "parentName": "",
                                "children": [],
                            },
                            parent: posInfo,
                            children: [],
                            expanded: false
                        };
                        posInfo.children.push(posChild);
                        _this.posItems.push(posInfo);
                        if (_this.injectorData && _this.injectorData != "") {
                            showDatas = JSON.parse(_this.injectorData);
                        }
                    }));
                    _this.posItems = __spread(_this.posItems);
                }));
            };
        /**
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.clearCheckeds = /**
         * @return {?}
         */
            function () {
                this.orgsComponent.clearCheckeds();
            };
        /**
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getResult = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var results = [];
                if (this.selectedData && this.selectedData.length > 0) {
                    this.selectedData.forEach(( /**
                     * @param {?} item
                     * @return {?}
                     */function (item) {
                        /** @type {?} */
                        var result = new Result;
                        result.id = item.id;
                        result.name = item.name;
                        result.recipientType = item.recipientType;
                        results.push(result);
                    }));
                }
                return JSON.stringify(results);
            };
        /**
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getSelectedUsers = /**
         * @return {?}
         */
            function () {
                if (this.selectedData && this.selectedData.length > 0) {
                    /** @type {?} */
                    var results_1 = [];
                    this.selectedData.forEach(( /**
                     * @param {?} item
                     * @return {?}
                     */function (item) {
                        if (item.recipientType == 2) {
                            if (!results_1.includes(item.id)) {
                                results_1.push(item.id);
                            }
                        }
                        else if (item.recipientType == 0) {
                            // this.getUsersByOrgId(item.id).subscribe(users=>{
                            //   users.data.forEach(user=>{
                            //     if(!results.includes(user.id)){
                            //       results.push(user.id);
                            //     };
                            //   });
                            // });
                            if (item.children && item.children.length > 0) {
                                item.children.forEach(( /**
                                 * @param {?} item
                                 * @return {?}
                                 */function (item) {
                                    if (!results_1.includes(item)) {
                                        results_1.push(item);
                                    }
                                }));
                            }
                        }
                    }));
                    return JSON.stringify(results_1);
                    // let orgs = this.selectedData.filter(item=>item.recipientType==1);
                    // if(orgs && orgs.length>0){
                    //   orgs.forEach(item=>{
                    //     this.getAllUsersByPosId(item.id).subscribe((users)=>{
                    //       users.children.forEach(user=>{
                    //         if(!results.includes(user.id)){
                    //           results.push(user.id);
                    //         };
                    //       })
                    //     })
                    //   });
                    // }
                    // else{
                    //   this.selectedData.forEach(item=>{
                    //     if(item.recipientType==2){ 
                    //       if(!results.includes(item.id)){
                    //         results.push(item.id);
                    //       };
                    //     }
                    //     else if(item.recipientType==1){
                    //     }
                    //   });
                    // }
                }
            };
        /**
         * @private
         * @param {?} children
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getChildSet = /**
         * @private
         * @param {?} children
         * @return {?}
         */
            function (children) {
                var _this = this;
                /** @type {?} */
                var list = [];
                children.forEach(( /**
                 * @param {?} item
                 * @return {?}
                 */function (item) {
                    if (item.recipientType == 2) {
                        if (!list.includes(item.id)) {
                            list.push(item.id);
                        }
                    }
                    else if (item.recipientType == 0) {
                        _this.getChildSet(item.children).forEach(( /**
                         * @param {?} userId
                         * @return {?}
                         */function (userId) {
                            if (!list.includes(userId)) {
                                list.push(userId);
                            }
                        }));
                    }
                }));
                return list;
            };
        //删除某一个选择项
        //删除某一个选择项
        /**
         * @param {?} $event
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.delete =
            //删除某一个选择项
            /**
             * @param {?} $event
             * @return {?}
             */
            function ($event) {
                /** @type {?} */
                var item = {
                    node: {
                        id: $event.id,
                        data: $event
                    }
                };
                this.nodeUnChecked(item);
            };
        //清空所选数据
        //清空所选数据
        /**
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.clearSelectedData =
            //清空所选数据
            /**
             * @return {?}
             */
            function () {
                this.selectedData = [];
                this.selectedAllCount = 0;
                this.selectedOrgCount = 0;
                this.selectedPosCount = 0;
                this.selectedUserCount = 0;
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.tabChange = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.tabsLebel = $event.nextId;
                this.checkAllList = false;
                if (this.tabsLebel === "Organize") {
                    this.orgsComponent.clearCheckeds();
                }
                else if (this.tabsLebel === "Position") {
                    this.possComponent.clearCheckeds();
                }
                this.searchText = "";
            };
        //选择统计数加1
        //选择统计数加1
        /**
         * @private
         * @param {?} recipientType
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.addSelectedOrgUserCount =
            //选择统计数加1
            /**
             * @private
             * @param {?} recipientType
             * @return {?}
             */
            function (recipientType) {
                if (recipientType == 0) {
                    this.selectedOrgCount++;
                    this.selectedAllCount++;
                }
                else if (recipientType == 1) {
                    this.selectedPosCount++;
                    this.selectedAllCount++;
                }
                else if (recipientType == 2) {
                    this.selectedUserCount++;
                    this.selectedAllCount++;
                }
            };
        //选择统计数减1
        //选择统计数减1
        /**
         * @private
         * @param {?} recipientType
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.removeSelectedOrgUserCount =
            //选择统计数减1
            /**
             * @private
             * @param {?} recipientType
             * @return {?}
             */
            function (recipientType) {
                if (recipientType == 0) {
                    if (this.selectedOrgCount > 0) {
                        this.selectedOrgCount--;
                    }
                    if (this.selectedAllCount > 0) {
                        this.selectedAllCount--;
                    }
                }
                else if (recipientType == 1) {
                    if (this.selectedPosCount > 0) {
                        this.selectedPosCount--;
                    }
                    if (this.selectedAllCount > 0) {
                        this.selectedAllCount--;
                    }
                }
                else if (recipientType == 2) {
                    if (this.selectedUserCount > 0) {
                        this.selectedUserCount--;
                    }
                    if (this.selectedAllCount > 0) {
                        this.selectedAllCount--;
                    }
                }
            };
        //搜索框事件
        //搜索框事件
        /**
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.clear =
            //搜索框事件
            /**
             * @return {?}
             */
            function () {
                if (this.tabsLebel === "Organize") {
                    this.treedata = __spread(this.orgList);
                }
                else {
                    this.posItems = __spread(this.posList);
                }
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.onChange = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                if ($event) {
                    if (this.tabsLebel === "Organize") {
                        this.treedata = [];
                        /** @type {?} */
                        var navTemp = _.cloneDeep(this.orgList);
                        this.treedata = this.matchFindText(navTemp, $event);
                        this.treedata = __spread(this.treedata);
                    }
                    else {
                        this.posItems = [];
                        /** @type {?} */
                        var navTemp = _.cloneDeep(this.posList);
                        this.posItems = this.matchFindText(navTemp, $event);
                        this.posItems = __spread(this.posItems);
                    }
                }
                else {
                    this.clear();
                }
            };
        /**
         * @param {?} nodes
         * @param {?} text
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.matchFindText = /**
         * @param {?} nodes
         * @param {?} text
         * @return {?}
         */
            function (nodes, text) {
                var _this = this;
                /** @type {?} */
                var xNodes = [];
                nodes.forEach(( /**
                 * @param {?} node
                 * @return {?}
                 */function (node) {
                    if (node.children && node.children.length > 0) {
                        /** @type {?} */
                        var xxNodes = _this.matchFindText(node.children, text);
                        if (xxNodes && xxNodes.length > 0) {
                            node.children = xxNodes;
                            xNodes.push(node);
                        }
                        else {
                            if (node.data.name.search(text) != -1) {
                                xNodes.push(node);
                            }
                        }
                    }
                    else {
                        if (node.data.name.search(text) != -1) {
                            xNodes.push(node);
                        }
                    }
                }));
                return xNodes;
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.nodeChecked = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                var _this = this;
                /** @type {?} */
                var findIndex = this.selectedData.findIndex(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) { return data.id === $event.node.id && data.recipientType === $event.node.data.recipientType; }));
                if (findIndex < 0) {
                    /** @type {?} */
                    var node_1 = $event.node;
                    if (node_1.data.recipientType == 0) {
                        this.getAllUsersByOrgIdWithNext(node_1.data.id).subscribe(( /**
                         * @param {?} users
                         * @return {?}
                         */function (users) {
                            node_1.data.userNumber = users.totalCount;
                            /** @type {?} */
                            var list = [];
                            users.data.forEach(( /**
                             * @param {?} user
                             * @return {?}
                             */function (user) {
                                list.push(user.id);
                            }));
                            node_1.data.children = list;
                            _this.selectedData.push(node_1.data);
                            _this.selectedData = __spread(_this.selectedData);
                            _this.addSelectedOrgUserCount(node_1.data.recipientType);
                        }));
                    }
                    else if (node_1.data.recipientType == 2) {
                        this.selectedData.push(node_1.data);
                        this.selectedData = __spread(this.selectedData);
                        this.addSelectedOrgUserCount(node_1.data.recipientType);
                    }
                }
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.nodeUnChecked = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                /** @type {?} */
                var findIndex = this.selectedData.findIndex(( /**
                 * @param {?} data
                 * @return {?}
                 */function (data) { return data.id === $event.node.id && data.recipientType === $event.node.data.recipientType; }));
                if (findIndex == 0) {
                    this.selectedData.shift();
                    this.removeSelectedOrgUserCount($event.node.data.recipientType);
                }
                else if (findIndex == this.selectedData.length - 1) {
                    this.selectedData.pop();
                    this.removeSelectedOrgUserCount($event.node.data.recipientType);
                }
                else if (0 < findIndex && findIndex < this.selectedData.length - 1) {
                    /** @type {?} */
                    var front = this.selectedData.slice(0, findIndex);
                    /** @type {?} */
                    var back = this.selectedData.slice(findIndex + 1, this.selectedData.length);
                    this.selectedData = front.concat(back);
                    this.removeSelectedOrgUserCount($event.node.data.recipientType);
                }
                this.selectedData = __spread(this.selectedData);
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.expandOrg = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                var _this = this;
                if ($event.parent) {
                    if (this.tabsLebel === "Organize") {
                        /** @type {?} */
                        var expandOrg = this.hasExpandOrg.find(( /**
                         * @param {?} item
                         * @return {?}
                         */function (item) { return item == $event.data.id; }));
                        if (!expandOrg) {
                            $event.children = [];
                            // this.treedata = [...this.treedata];
                            this.getAllUsersByOrgId($event.data.id).subscribe(( /**
                             * @param {?} users
                             * @return {?}
                             */function (users) {
                                $event.data.userNumber = users.totalCount;
                                /** @type {?} */
                                var list = [];
                                users.data.forEach(( /**
                                 * @param {?} user
                                 * @return {?}
                                 */function (user) {
                                    /** @type {?} */
                                    var userInfo = {
                                        data: {
                                            "id": user.id,
                                            "code": user.code,
                                            "name": user.name,
                                            "parentId": user.sysOrgId,
                                            "parentName": $event.data.name,
                                            "isDetail": true,
                                            "recipientType": RecipientType.User,
                                            "userNumber": 0,
                                        },
                                        parent: $event,
                                        children: [],
                                        expanded: false
                                    };
                                    list.push(userInfo);
                                    // $event.children.push(userInfo);
                                }));
                                _this.orgsComponent.appendChildren(list, $event);
                                // this.treedata = [...this.treedata];
                            }));
                            this.getOrgsByParentId($event.data.id).subscribe(( /**
                             * @param {?} orgs
                             * @return {?}
                             */function (orgs) {
                                if (orgs) {
                                    /** @type {?} */
                                    var list_1 = [];
                                    orgs.forEach(( /**
                                     * @param {?} item
                                     * @return {?}
                                     */function (item) {
                                        /** @type {?} */
                                        var org = {
                                            data: {
                                                "id": item.id,
                                                "code": item.code,
                                                "name": item.name,
                                                "parentId": item.parentId,
                                                "isDetail": item.isDetail,
                                                "recipientType": RecipientType.Organize,
                                                "userNumber": 0,
                                                "parentName": "",
                                            },
                                            parent: $event,
                                            children: [],
                                            expanded: false
                                        };
                                        /** @type {?} */
                                        var orgChild = {
                                            data: {
                                                "id": _this.newGuid(),
                                                "code": "",
                                                "name": "",
                                                "parentId": "",
                                                "isDetail": true,
                                                "recipientType": RecipientType.User,
                                                "userNumber": 0,
                                                "parentName": "",
                                                "children": [],
                                            },
                                            parent: org,
                                            children: [],
                                            expanded: false
                                        };
                                        org.children.push(orgChild);
                                        list_1.push(org);
                                        // $event.children.push(org);
                                    }));
                                    _this.orgsComponent.appendChildren(list_1, $event);
                                    // this.treedata = [...this.treedata];
                                }
                            }));
                            this.hasExpandOrg.push($event);
                            // this.treedata = [...this.treedata];
                        }
                    }
                    else {
                        $event.children = [];
                        this.posItems = __spread(this.posItems);
                        this.getAllUsersByPosId($event.data.id).subscribe(( /**
                         * @param {?} users
                         * @return {?}
                         */function (users) {
                            $event.data.userNumber = users.length;
                            users.forEach(( /**
                             * @param {?} user
                             * @return {?}
                             */function (user) {
                                /** @type {?} */
                                var userInfo = {
                                    data: {
                                        "id": user.id,
                                        "code": user.code,
                                        "name": user.name,
                                        "parentId": user.sysOrgId,
                                        "parentName": $event.data.name,
                                        "isDetail": true,
                                        "recipientType": RecipientType.User,
                                        "userNumber": 0,
                                    },
                                    parent: $event,
                                    children: [],
                                    expanded: false
                                };
                                $event.children.push(userInfo);
                            }));
                            _this.posItems = __spread(_this.posItems);
                            // this.posList = _.cloneDeep(this.posItems);
                            //注入数据显示
                            // if(showDatas && showDatas.length>0){
                            //   let posItem = showDatas.find(item=>item.id===posInfo.data.id && item.recipientType==1);
                            //   if(posItem){
                            //     this.selectedData.push(posInfo.data);
                            //     this.selectedData = [...this.selectedData]; 
                            //     this.selectedPosCount++;
                            //     this.selectedAllCount++;
                            //   }
                            // }
                        }));
                    }
                }
            };
        //自动生成随机码
        //自动生成随机码
        /**
         * @private
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.newGuid =
            //自动生成随机码
            /**
             * @private
             * @return {?}
             */
            function () {
                var _this = this;
                /** @type {?} */
                var initString = 'xxxx-xx';
                /** @type {?} */
                var result = initString.replace(/[xy]/g, ( /**
                 * @param {?} c
                 * @return {?}
                 */function (c) {
                    return _this.convert(c);
                }));
                return result;
            };
        /**
         * @private
         * @param {?} c
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.convert = /**
         * @private
         * @param {?} c
         * @return {?}
         */
            function (c) {
                /** @type {?} */
                var r = Math.random() * 16 | 0;
                /** @type {?} */
                var v = c === 'x' ? r : (r & 0x3 | 0x8);
                return v.toString(16);
            };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getUserById = /**
         * @private
         * @param {?} id
         * @return {?}
         */
            function (id) {
                /** @type {?} */
                var url = "/api/runtime/sys/v1.0/users/" + id;
                return this.http.get(url);
            };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getUsersByOrgId = /**
         * @private
         * @param {?} id
         * @return {?}
         */
            function (id) {
                /** @type {?} */
                var url = "/api/runtime/sys/v1.0/users?param={\"orgId\":\"" + id + "\"}";
                return this.http.get(url);
            };
        /**
         * @private
         * @param {?} layer
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getOrgsByLayer = /**
         * @private
         * @param {?} layer
         * @return {?}
         */
            function (layer) {
                /** @type {?} */
                var url = "/api/runtime/sys/v1.0/sysOrgs?param={\"layer\":\"" + layer + "\"}";
                return this.http.get(url);
            };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getOrgsByParentId = /**
         * @private
         * @param {?} id
         * @return {?}
         */
            function (id) {
                /** @type {?} */
                var url = "/api/runtime/sys/v1.0/sysOrgs?param={\"parentId\":\"" + id + "\"}";
                return this.http.get(url);
            };
        // private getAllUsersByOrgId(id:String): Observable<any> {
        //   return this.http.post('/api/runtime/sys/v1.0/messagecenter/recipicent/orguser',id);
        // }
        // private getAllUsersByOrgId(id:String): Observable<any> {
        //   return this.http.post('/api/runtime/sys/v1.0/messagecenter/recipicent/orguser',id);
        // }
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getAllUsersByOrgId =
            // private getAllUsersByOrgId(id:String): Observable<any> {
            //   return this.http.post('/api/runtime/sys/v1.0/messagecenter/recipicent/orguser',id);
            // }
            /**
             * @private
             * @param {?} id
             * @return {?}
             */
            function (id) {
                /** @type {?} */
                var url = "/api/runtime/sys/v1.0/users?param={\"orgId\":\"" + id + "\",\"withAllOrg\":false}";
                return this.http.get(url);
            };
        /**
         * @private
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getAllPoss = /**
         * @private
         * @return {?}
         */
            function () {
                return this.http.get('/api/runtime/sys/v1.0/messagecenter/recipicent/allposs');
            };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getAllUsersByPosId = /**
         * @private
         * @param {?} id
         * @return {?}
         */
            function (id) {
                return this.http.post('/api/runtime/sys/v1.0/messagecenter/recipicent/posuser', id);
            };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getPosByPosId = /**
         * @private
         * @param {?} id
         * @return {?}
         */
            function (id) {
                return this.http.get('/api/runtime/sys/v1.0/positions/' + id);
            };
        /**
         * @private
         * @param {?} id
         * @return {?}
         */
        MessageUserSelectorComponent.prototype.getAllUsersByOrgIdWithNext = /**
         * @private
         * @param {?} id
         * @return {?}
         */
            function (id) {
                /** @type {?} */
                var url = "/api/runtime/sys/v1.0/users?param={\"orgId\":\"" + id + "\"}";
                return this.http.get(url);
            };
        MessageUserSelectorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'message-user-selector',
                        template: "<div id=\"select\" class=\"f-utils-fill\" style=\"height:100%\">\r\n    <div id=\"left\" style=\"width:50%;height:100%;float:left;padding-left: 6px;\">\r\n      <div style=\"border:1px solid rgb(235, 233, 233);padding: 4px;height:100%\">\r\n        <farris-tabs style=\"height:100%\" [value]=\"'Organize'\" [contentFill]=\"true\" [showDropDown]=\"false\" (tabChange)=\"tabChange($event)\">\r\n            <farris-tab title=\"\u6700\u8FD1\" [id]=\"'Common'\">\r\n                <ng-template #content>\r\n                    <div style=\"height:100%\">\r\n                      \r\n                    </div>\r\n                </ng-template>\r\n            </farris-tab>\r\n            <farris-tab title=\"\u7EC4\u7EC7\u7ED3\u6784\" [id]=\"'Organize'\">\r\n                <ng-template #content>\r\n                    <div style=\"height:100%\">\r\n                      <!-- <ol class=\"breadcrumb\" style=\"margin-bottom:5px;padding:10px\">\r\n                          <div *ngFor=\"let organize of selectOrganizes; let i = index;let last = last;\">\r\n                              <div *ngIf=\"!last\">\r\n                                  <li class=\"breadcrumb-item\">\r\n                                      <a href=\"javascript: void(0);\" (click)=\"selectOrg(organize,i)\">{{organize.name}}&nbsp;>&nbsp;</a>\r\n                                  </li>\r\n                              </div>\r\n                          <li *ngIf=\"last\" class=\"breadcrumb-item active\" aria-current=\"page\">{{organize.name}}</li>\r\n                          </div>\r\n                      </ol> -->\r\n                      <!-- <div class=\"custom-control custom-checkbox custom-control-inline\" style=\"margin-bottom:5px;margin-left:10px\">\r\n                              <input type=\"checkbox\" class=\"custom-control-input\" [(ngModel)]=\"checkAllList\"\r\n                                  (click)=\"selectAll()\" id=\"selectAllList\">\r\n                              <label class=\"custom-control-label\" for=\"selectAllList\">&nbsp;&nbsp;&nbsp;&nbsp;\u5168\u9009({{orgUserCount}}\u4EBA)</label>\r\n                      </div> -->\r\n                      <input-group class=\"myinput\" [groupText]=\"groupIcon\" [(value)]=\"searchText\"\r\n                                  (valueChange)=\"onChange($event)\" (clear)=\"clear()\"></input-group>\r\n                      <div style=\"height:300px;width: 100%;\">\r\n                      \r\n                      <farris-treetable #orgs class=\"f-componet-treetable\" \r\n                      [data]=\"treedata\" \r\n                      [columns]=\"columns\" \r\n                      [idField]=\"'id'\"\r\n                      [showFilterBar]=\"false\" \r\n                      [fixedHeader]=\"true\" \r\n                      [fit]=\"true\" \r\n                      [fitColumns]=\"false\" \r\n                      [striped]=\"true\"\r\n                      [showBorder]=\"false\"\r\n                      [singleSelect]=\"false\"\r\n                      [checkOnSelect]=\"false\" \r\n                      [selectOnCheck]=\"false\"\r\n                      [showCheckbox]=\"true\"\r\n                      [cascadeCheck]=\"false\"\r\n                      [virtualized]=\"true\"\r\n                      (nodeChecked)=\"nodeChecked($event)\"\r\n                      (nodeUnChecked)=\"nodeUnChecked($event)\"\r\n                      (expand)=\"expandOrg($event)\"\r\n                      >\r\n                      </farris-treetable>\r\n                      </div>\r\n                    </div>\r\n                </ng-template>\r\n            </farris-tab>\r\n            <!-- <farris-tab title=\"\u5C97\u4F4D\u7C7B\u578B\" [id]=\"'Position'\">\r\n                <ng-template #content>\r\n                    <div style=\"height:100%\">\r\n                      <input-group class=\"myinput\" [groupText]=\"groupIcon\" [(value)]=\"searchText\"\r\n                      (valueChange)=\"onChange($event)\" (clear)=\"clear()\"></input-group>\r\n                      <div style=\"height:290px;width: 100%;\">\r\n                      \r\n                      <farris-treetable #poss class=\"f-componet-treetable\" \r\n                      [data]=\"posItems\" \r\n                      [columns]=\"columns\" \r\n                      [idField]=\"'id'\"\r\n                      [showFilterBar]=\"false\" \r\n                      [fixedHeader]=\"true\" \r\n                      [fit]=\"true\" \r\n                      [fitColumns]=\"false\" \r\n                      [striped]=\"true\"\r\n                      [showBorder]=\"false\"\r\n                      [showHeader]=\"false\"\r\n                      [singleSelect]=\"false\"\r\n                      [checkOnSelect]=\"true\" \r\n                      [selectOnCheck]=\"false\"\r\n                      [showCheckbox]=\"true\"\r\n                      [cascadeCheck]=\"false\"\r\n                      [virtualized]=\"true\"\r\n                      (nodeChecked)=\"nodeChecked($event)\"\r\n                      (nodeUnChecked)=\"nodeUnChecked($event)\"\r\n                      (expand)=\"expandOrg($event)\"\r\n                      >\r\n                      </farris-treetable>\r\n                      </div>\r\n                    </div>\r\n                </ng-template>\r\n            </farris-tab>  -->\r\n        </farris-tabs>\r\n      </div>\r\n    </div>\r\n    <div id=\"right\" style=\"width:50%;height:100%;float: left;padding-left: 5px;padding-right: 6px;\">\r\n        <div style=\"border:1px solid rgb(235, 233, 233);padding: 4px;height:100%;\">\r\n              <div class=\"d-flex\" style=\"line-height:22px;margin-bottom:4px;line-height: 30px;padding-right:10px;padding-left:10px;\">\r\n                      <div class=\"listview-item-title f-utils-fill\" style=\"margin-bottom: 2px;\" >\r\n                          \u5DF2\u9009{{selectedAllCount}}\u9879\r\n                          <span style=\"font-size: 12px;padding-left:10px\">\r\n                              (\u4EBA{{selectedUserCount}}\uFF0C\u7EC4\u7EC7{{selectedOrgCount}}\uFF0C\u5C97\u4F4D{{selectedPosCount}})\r\n                          </span>\r\n                      </div>\r\n                      <div class=\"listview-item-time\" style=\"font-size: 13px;\">\r\n                          <a href=\"javascript:void(0);\" class=\"myclearall\" (click)=\"clearSelectedData()\">\u6E05\u7A7A\u5DF2\u9009</a>\r\n                      </div>\r\n              </div>\r\n              <farris-list-view #myListView [data]=\"selectedData\" [multipleSelect]=\"false\" [supportPaging]=\"false\" [fill]=\"true\">\r\n                      <ng-template listTemplate let-item=\"item\">\r\n                          <div class=\"f-template-common-row d-flex f-selector-listview-container\" style=\"margin-top: 5px;width: 100%\">\r\n                              <div *ngIf=\"item.recipientType==2\" class=\"item-action-primary\" style=\"margin-right: 15px;padding: top 5px;\">\r\n                                  <img [src]=\"imgSrc\" class=\"ap-img\" width=\"35\" height=\"35\">\r\n                              </div>\r\n                              <div *ngIf=\"item.recipientType==2\" class=\"listview-item-content d-flex k-align-items-center f-utils-fill\" style=\"border-bottom:1px solid #d9d9d9;padding-bottom: 5px;\">\r\n                                  <div class=\"listview-item-main f-utils-fill\">\r\n                                      <div class=\"d-flex\" style=\"line-height:25px;margin-bottom:0px;\">\r\n                                          <div class=\"listview-item-title f-utils-fill item-sender\" >\r\n                                              {{item.name}} &nbsp;<span style=\"font-size: 14px;color: rgb(190, 192, 196);\">{{item.code}}</span>\r\n                                          </div>\r\n                                          <div class=\"listview-item-time\">\r\n                                                  <span class=\"f-icon f-icon-close text-info\" (click)=\"delete(item)\"></span>\r\n                                          </div>\r\n                                      </div>\r\n                                      <div class=\"listview-item-mes\" style=\"font-size:12px;color: rgb(189, 191, 194);margin-top: 4px;\">\r\n                                              {{item.parentName}}\r\n                                      </div>\r\n                                  </div>\r\n                              </div>\r\n                              <div *ngIf=\"item.recipientType!==2\" class=\"listview-item-content d-flex k-align-items-center f-utils-fill\" style=\"border-bottom:1px solid #d9d9d9;padding-bottom: 5px;\">\r\n                                      <div class=\"listview-item-main f-utils-fill\">\r\n                                          <div class=\"d-flex\" style=\"line-height:22px;margin-bottom:0px;\">\r\n                                              <div class=\"listview-item-title f-utils-fill item-sender\" >\r\n                                                  &nbsp;&nbsp;{{item.name}}\uFF08\u5305\u542B{{item.userNumber}}\u4EBA\uFF09\r\n                                              </div>\r\n                                              <div class=\"listview-item-time\">\r\n                                                      <span class=\"f-icon f-icon-close text-info\" (click)=\"delete(item)\"></span>\r\n                                              </div>\r\n                                          </div>\r\n                                      </div>\r\n                              </div>\r\n                          </div>\r\n                      </ng-template>\r\n                  </farris-list-view>\r\n        </div>       \r\n    </div>\r\n  </div>",
                        styles: [".template-step-footer{padding-top:6px;padding-bottom:6px}.step-progress{margin-top:5px;margin-left:20px}:host{flex:1 1 0;position:relative}.operator{padding-top:15px;padding-right:0;text-align:right;margin-bottom:8px}.template-fenge-line{border-top:1px dashed #ccd2e1;padding-top:15px;padding-right:0;text-align:right;margin-top:15px}.template-editor{margin-top:10px}.myclearall{margin-left:5px;text-decoration:none;text-align:center;color:#3b91ff;padding:right 8px}.item-sender{font-family:PingFangSC-Regular;font-size:18px;color:rgba(0,0,0,.85);text-align:left}.cbtn{background-image:linear-gradient(225deg,#49b4ff 0,#3b91ff 100%);border-radius:17px}.mylink{margin-left:5px;text-decoration:underline;text-align:center;color:#7480a6}.f-message-files{display:flex;flex-wrap:wrap}.f-message-files-item{display:flex;align-items:center;justify-content:space-between;width:150px;height:41px;min-height:40px;margin-right:10px;margin-bottom:0;padding-left:7px;background:#fff;border:1px solid #d9dfe6;box-shadow:0 2px 10px 0 rgba(0,32,74,.04);border-radius:6px}.f-message-files-item .file-item-left{display:flex;align-items:flex-start}.f-message-files-item .file-item-left .file-item-img{width:20px;margin-top:6px}.f-message-files-item .file-item-left .file-item-img img{display:block;width:20px;height:24px}.f-message-files-item .file-item-left .file-item-text{margin-left:10px}.f-message-files-item .file-item-left .file-item-text .file-item-name{margin-bottom:0;line-height:20px;font-size:14px;color:rgba(0,0,0,.85);white-space:nowrap;text-overflow:ellipsis;overflow:hidden}.f-message-files-item .file-item-left .file-item-text .file-item-size{font-size:12px;color:rgba(0,0,0,.45)}.f-message-files-item .file-item-right{display:flex;align-items:center}.f-message-files-item .file-item-right .file-item-btn{padding:0 8px;line-height:58px;cursor:pointer}.f-message-files-item .file-item-right .file-item-btn .f-icon{font-size:10px;color:#4d97ff}.f-message-files-item .file-item-right .file-item-btn:hover .f-icon{color:#2a87ff}.f-selector-listview-container .item-sender{font-family:PingFangSC-Regular;font-size:14px;color:rgba(0,0,0,.85);text-align:left}.myinput{margin-bottom:6px}"]
                    }] }
        ];
        /** @nocollapse */
        MessageUserSelectorComponent.ctorParameters = function () {
            return [
                { type: cafCommon.HttpService }
            ];
        };
        MessageUserSelectorComponent.propDecorators = {
            orgsComponent: [{ type: core.ViewChild, args: ['orgs',] }],
            possComponent: [{ type: core.ViewChild, args: ['poss',] }]
        };
        return MessageUserSelectorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MessageUserSelectorModule = /** @class */ (function () {
        function MessageUserSelectorModule() {
        }
        MessageUserSelectorModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [MessageUserSelectorComponent],
                        imports: [
                            common.CommonModule,
                            uiListNav.ListNavModule,
                            uiListView.ListViewModule,
                            uiSection.FarrisSectionModule,
                            uiSidebar.FarrisSidebarModule,
                            uiComboList.ComboListModule,
                            uiForms.FarrisFormsModule,
                            forms.FormsModule,
                            uiModal.ModalModule.forRoot(),
                            uiDatagridEditors.DatagridEditorsModule,
                            uiMessager.MessagerModule,
                            uiNotify.NotifyModule,
                            uiViewChange.ViewChangeModule,
                            uiInputGroup.InputGroupModule,
                            uiDatepicker.FarrisDatePickerModule,
                            uiTabs.FarrisTabsModule,
                            uiTreetable.TreeTableModule,
                            uiDatagrid.DatagridModule.forRoot(__spread(uiDatagridEditors.EditorProviders))
                        ],
                        entryComponents: [MessageUserSelectorComponent],
                        exports: [MessageUserSelectorComponent],
                        providers: [uiModal.BsModalService, cafCommon.HttpService]
                    },] }
        ];
        return MessageUserSelectorModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.MessageUserSelectorComponent = MessageUserSelectorComponent;
    exports.MessageUserSelectorModule = MessageUserSelectorModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=gsp-svc-message-user-selector.umd.js.map