import { OnInit } from '@angular/core';
import { HttpService } from '@ecp-caf/caf-common';
import { TreeTableComponent } from '@farris/ui-treetable';
export declare class MessageUserSelectorComponent implements OnInit {
    private http;
    columns: any[];
    treedata: any[];
    groupIcon: string;
    searchText: string;
    orgList: any[];
    posList: any[];
    userInfos: any[];
    recipientInfos: any[];
    orgItems: any[];
    posItems: any[];
    checkAllList: boolean;
    orgUserCount: number;
    sysOrgRoot: any;
    posuserCount: number;
    isChildren: boolean;
    tabsLebel: string;
    selectedData: any[];
    selectedAllCount: number;
    selectedUserCount: number;
    selectedOrgCount: number;
    selectedPosCount: number;
    injectorData: string;
    hasExpandOrg: any[];
    orgsComponent: TreeTableComponent;
    possComponent: TreeTableComponent;
    imgSrc: string;
    UserFieldFormatter: (val: any, data: any) => any;
    constructor(http: HttpService);
    ngOnInit(): void;
    convertOrgTree(): void;
    convertPosTree(): void;
    clearCheckeds(): void;
    getResult(): string;
    getSelectedUsers(): string;
    private getChildSet;
    delete($event: any): void;
    clearSelectedData(): void;
    tabChange($event: any): void;
    private addSelectedOrgUserCount;
    private removeSelectedOrgUserCount;
    clear(): void;
    onChange($event: any): void;
    matchFindText(nodes: any, text: any): any[];
    nodeChecked($event: any): void;
    nodeUnChecked($event: any): void;
    expandOrg($event: any): void;
    private newGuid;
    private convert;
    private getUserById;
    private getUsersByOrgId;
    private getOrgsByLayer;
    private getOrgsByParentId;
    private getAllUsersByOrgId;
    private getAllPoss;
    private getAllUsersByPosId;
    private getPosByPosId;
    private getAllUsersByOrgIdWithNext;
}
